-- Tables

---- Collectibles collectable by the fairy

/*ARTH_Ace.AceCollectible[name] = collectable

name: -- The name of the collectible.
collectable: -- If true, it's collectable. If false, it's not collectable.*/

if not ARTH_Ace.AceCollectible
	rawset(ARTH_Ace, "AceCollectible", {})
end
ARTH_Ace.AceCollectible[MT_RING] = true
ARTH_Ace.AceCollectible[MT_FLINGRING] = true
ARTH_Ace.AceCollectible[MT_COIN] = true
ARTH_Ace.AceCollectible[MT_FLINGCOIN] = true
ARTH_Ace.AceCollectible[MT_TOKEN] = true
ARTH_Ace.AceCollectible[MT_BLUESPHERE] = true
addHook("ThinkFrame", function(player)
	if splitscreen return end
	
	for player in players.iterate
		if player.realmo
			if player.ctfteam == 1
				ARTH_Ace.AceCollectible[MT_REDTEAMRING] = true
				ARTH_Ace.AceCollectible[MT_BLUETEAMRING] = false
			elseif player.ctfteam == 2
				ARTH_Ace.AceCollectible[MT_REDTEAMRING] = false
				ARTH_Ace.AceCollectible[MT_BLUETEAMRING] = true
			end
		end
	end
end)

-- Functions

---- Healing for Ace's Health System

/*ARTH_Ace.AceHeal(player, sound)

player: -- The player.
sound: -- If true or nil, it will play the healing sound. If false, it won't play the healing sound.*/

if not ARTH_Ace.AceHeal
	rawset(ARTH_Ace, "AceHeal", function(player, sound) 
		if player and player.valid
		and player.acefairy and player.acefairy.valid
		and player.acefairy.target.skin == "ace"
		and player.powers[pw_carry] != CR_NIGHTSMODE
		and player.powers[pw_carry] != CR_NIGHTSFALL
			if player.acefairy.health < 4
				player.acefairy.health = $+1
				
				if sound != false
					S_StartSound(special, sfx_hoop1)
				end
			end
		end
	end)
end

/*ARTH_Ace.SpawnFlower(mobj, player, target)

mobj: -- The object you're spawning the flower from.
player: -- The player.
target: -- If true, it will home in on the player. If false or nil, it won't home in on the player.*/

if not ARTH_Ace.SpawnFlower
	rawset(ARTH_Ace, "SpawnFlower", function(mobj, player, target)
		local Flower = P_SpawnMobj(mobj.x, mobj.y, mobj.z, MT_ACEFLOWER)
				
		if player.acefairy.health == 4
			Flower.flags = $&~MF_SPECIAL
		end
		
		if P_MobjFlip(mobj) > 0
			Flower.flags2 = $&~MF2_OBJECTFLIP
			Flower.eflags = $&~MFE_VERTICALFLIP
		else
			Flower.flags2 = $|MF2_OBJECTFLIP
			Flower.eflags = $|MFE_VERTICALFLIP
		end
		
		if target
			Flower.target = player.mo
		end
	end)
end

-- Commands

---- Ace's Health System

if not ARTH_Ace.AceHealth
	rawset(ARTH_Ace, "AceHealth", CV_RegisterVar({
		name = "acehealth",
		defaultvalue = "On",
		flags = CV_NETVAR|CV_CALL,
		PossibleValue = CV_OnOff,
		func = function(cv)
			if cv.value
				print("\x84\Ace's Health System is on.")
			else
				print("\x84\Ace's Health System is off.")
			end
		end
	}))
end